/*Sweet Tea by Jessica Olesky
 You have a tea mug in front of you, and to your surprise it has a face on it.
 You do what any other normal person would do and put sugar into the living breathing adorable tea cup.
 To do this, click on the sugar cube pile and drag a sugar cube into the cup to appease the totally harmless living mug.
 Watch in awe as the cup changes expressions from cute to super cute.
 */

//Steam
//Steamball 1
float steamDiam = random(40, 50);
float steamX = random(145, 235);
float steamY = 240;
//Steamball 2
float steamDiamD = random(30, 35);
float steamXx = random(145, 235);
float steamYy = 240;
//Steamball 3
float steamDiamDd = random(20, 25);
float steamXxX = random(145, 235);
float steamYyY = 240;
//Steamball 4
float steamDiamFour = random(10, 50);
float steamXFour = random(145, 235);
float steamYFour = 240;
//Steamball 5
float steamDiamFive = random(15, 20);
float steamXFive = random(145, 235);
float steamYFive = 240;

//Sugar Cube
float sugarCube=0;
float sugarCubePickedUp=0;
float i=0;

//Cup Face
boolean showSweetFace=false;

void setup() {
  size(400, 400);
  rectMode(CORNERS);
  ellipseMode(CENTER);
  noStroke();
  smooth(8);
}

void draw() {
  background(200);
  rectMode(CORNERS);

  steamPosition(); 
  steamPositionTwo();
  steamPositionThree();
  steamPositionFour();
  steamPositionFive();

  //Steam Image
  fill(255, 80);
  ellipse(steamX, steamY, steamDiam, steamDiam);
  ellipse(steamXx, steamYy, steamDiamD, steamDiamD);
  ellipse(steamXxX, steamYyY, steamDiamDd, steamDiamDd);
  ellipse(steamXFour, steamYFour, steamDiamFour, steamDiamFour);
  ellipse(steamXFive, steamYFive, steamDiamFive, steamDiamFive);



  //Lemon Slice Image
  noStroke();
  fill(#FAF479);
  ellipse(340, 310, 70, 70);
  fill(255);
  ellipse(340, 310, 65, 65);
  fill(#FAF7BB);
  ellipse(340, 310, 55, 55);
  stroke(255);
  line(340, 310, 340, 335);
  line(340, 310, 360, 325);
  line(340, 310, 365, 301);
  noStroke();
  fill(200);
  quad(300, 360, 300, 300, 340, 250, 380, 250);


  //Monster Base
  //Monster Cup
  fill(255);
  noStroke();
  ellipse(275, 240, 85, 155);
  ellipse(275, 240, 80, 150);
  fill(200);
  ellipse(275, 240, 55, 130);
  fill(255);
  rect(120, 160, 260, 320);

  //Monster Body
  fill(#80AD3F);
  rect(140, 200, 240, 300);
  fill(0);
  triangle(140, 200, 160, 200, 150, 180);
  triangle(220, 200, 240, 200, 230, 180);



  //Monster Normal Face
  //Monster Eye
  noStroke();
  fill(255);
  ellipse(190, 240, 60, 60);
  fill(0);
  ellipse(190, 240, 40, 40);

  //Monster Mouth
  stroke(0);
  arc(180, 280, 25, 25, 0, PI+QUARTER_PI, OPEN); 
  displaySweetFace();

  //Sugar Cube Pile Image
  noStroke();
  rectMode(CENTER);
  fill(230);
  rect(30, 330, 20, 20);
  fill(235);
  rect(50, 330, 20, 20);
  fill(240);
  rect(70, 330, 20, 20);
  fill(233);
  rect(40, 310, 20, 20);
  fill(240);
  rect(60, 310, 20, 20);
  fill(250);
  rect(50, 290, 20, 20);

  //Sugar Cube Actions/Functions
  spawnSugarCube();
  displaySugarCube();
  makeSugarDisappear();
}


//FUNCTIONS


//Position of steam ball 1. Steam ball 1 is made bigger than steam ball 3 and made to spawn near the same time as steam ball 3
void steamPosition() {
  steamY--;
  if (steamY<-60) {
    steamX=random(140, 240);
    steamY=(240);
  }
}

//Position of steam ball 2. Steam ball 2 is wild card and does not complement with other steam balls.
void steamPositionTwo() {
  steamYy--;
  if (steamYy<-50) {
    steamXx=random(140, 240);
    steamYy=(240);
  }
}

//Position of steam ball 3. Steam ball 3 is made to pair up with steam ball 1.
void steamPositionThree() {
  steamYyY--;
  if (steamYyY<-61) {
    steamXxX=random(140, 240);
    steamYyY=(240);
  }
}

//Position of steam ball 4. Steam ball 4 is made to pair up with steam ball 5.
void steamPositionFour() {
  steamYFour--;
  if (steamYFour<-30) {
    steamXFour=random(140, 240);
    steamYFour=(240);
  }
}

//Position of steam ball 5.
void steamPositionFive() {
  steamYFive--;
  if (steamYFive<-31) {
    steamXFive=random(140, 240);
    steamYFive=(240);
  }
}

//Spawning box overtop of Sugar Cube Pile Image
void spawnSugarCube() {
  if ((mouseX>20)&&(mouseX<80)&&(mouseY<340)&&(mouseY>280)&&(mousePressed==true)&&(sugarCube==0)) {
    sugarCube=(sugarCube+1);
    sugarCubePickedUp=(sugarCubePickedUp+1);
  }
}

//Image of Sugar Cube that follows mouse
void displaySugarCube() {
  if (sugarCubePickedUp==1) {
    rectMode(CENTER);
    fill(255);
    rect(mouseX, mouseY, 20, 20);
  }
}

//Hit box that removes the Sugar Cube
void makeSugarDisappear() {
  if ((sugarCubePickedUp==1)&&(mouseX>130)&&(mouseX<250)&&(mouseY>180)&&(mouseY<280)) {
    sugarCube=(sugarCube-1);
    sugarCubePickedUp=(sugarCubePickedUp-1);
  }
}

//Same hit box as above but this makes the face change expressions
void displaySweetFace() {
  if ((sugarCubePickedUp==1)&&(mouseX>130)&&(mouseX<250)&&(mouseY>180)&&(mouseY<280)) {
    showSweetFace=true;
  }


  if (showSweetFace==true) {
    noStroke();
    fill(255);
    ellipse(190, 240, 60, 60);
    fill(0);
    ellipse(190, 240, 50, 50);
    fill(#80AD3F);
    ellipse(190, 257, 60, 63);
    fill(#80AD3F);
    ellipse(158, 249, 20, 20);
    ellipse(220, 249, 20, 20);

    //Monster Sweet Mouth
    fill(#80AD3F);
    rect(160, 260, 230, 300);
    stroke(0);
    noFill();
    ellipse(181, 282, 17, 17);
    ellipse(199, 282, 17, 17);
    noStroke();
    fill(#80AD3F);
    rect(170, 270, 210, 280);
    fill(#FA88E0, 80);
    ellipse(160, 260, 16, 11);
    ellipse(220, 260, 16, 11);
  } else { 
    //Normal Monster Face
    noStroke();
    fill(255);
    ellipse(190, 240, 60, 60);
    fill(0);
    ellipse(190, 240, 40, 40);

    //Normal Monster Mouth
    stroke(0);
    arc(180, 280, 25, 25, 0, PI+QUARTER_PI, OPEN);
  }
}
